;---- Screen erstellen ----

InitMouse()
InitSprite()
InitKeyboard()

UsePNGImageDecoder()

OpenScreen(800, 600, 16, "Font-Machine")

;---- Schriftarten laden ----

;NEU! Jetzt die Dateierweiterung der Bitmap mit angeben - somit kann jedes Grafikformat verwendet werden
;Das zugehrige Datenfile (*.font) wird anhand der geladenen Grafikdatei automatisch ermittelt

IncludeFile "Include\FontMapSystem.pbi"

FontID1 = FontMapLoad("Fonts\Bennyfnt.png") ;---- NEU! Hier wird z.B. eine PNG-Datei geladen
FontID2 = FontMapLoad("Fonts\Monkey1.bmp")
FontID3 = FontMapLoad("Fonts\Fugger2.bmp")
FontID4 = FontMapLoad("Fonts\Snowfont.bmp")
FontID5 = FontMapLoad("Fonts\Tentacle.bmp")
FontIDA = FontMapLoad("Fonts\Rocky.png") ;------- NEU! Hier wird z.B. eine PNG-Datei geladen
FontID6 = FontMapLoad("Fonts\AgastLarge.bmp")
FontID7 = FontMapLoad("Fonts\ComicGreen.bmp")
FontID8 = FontMapLoad("Fonts\Algonet184.bmp")

;---- Hauptschleife ----

text$ = "PureBasic ist klasse!" + #CR$
text$ + "Bitte mal die Zifferntasten auf" + #CR$
text$ + "dem Num-Pad ausprobieren!"

font = FontID5: col = $FFFFFF: hori = #FHC: vert = #FVC

Repeat

  ExamineMouse()
  ExamineKeyboard()
    
  ClearScreen(0,40,80)

  StartDrawing(ScreenOutput())
  LineXY(MouseX(),MouseY()-80,MouseX(),MouseY()+80, $0000FF)
  LineXY(MouseX()-80,MouseY(),MouseX()+80,MouseY(), $0000FF)
  StopDrawing()

  FontMapOutput(FontID1, "POWER OF PUREBASIC 3.93", 400, 50, #FHC, #FVT, 0)
  FontMapOutput(FontID2, Str(MouseX()) + "," + Str(MouseY()), 780, 20, #FHR, #FVT, $009CFF)
  FontMapOutput(FontID3, "Es war einmal vor langer Zeit...", 10, 110, #FHL, #FVT, 0)
  FontMapOutput(FontID3, "Ein Ring sie zu knechten, sie alle zu finden...", 40, 140, #FHL, #FVT, 0)
  FontMapOutput(FontID4, "Das ist eine Testzeile", 780, 500, #FHR, #FVB, $400CC0)
  FontMapOutput(FontID4, "Das ist eine Testzeile", 780, 540, #FHR, #FVB, $78DC68)
  FontMapOutput(FontID4, "Das ist eine Testzeile", 780, 580, #FHR, #FVB, $787488)
  FontMapOutput(FontID6, "Timer: " + Str(ElapsedMilliseconds()), 10, 535, #FHL, #FVB, $28F0D8)
  FontMapOutput(FontID7, "Datum: " + FormatDate("%dd.%mm.%yyyy", Date()), 10, 600, #FHL, #FVB, 0)
  FontMapOutput(FontID8, "WWW.PUREBASIC.COM", 400, 200, #FHC, #FVT, 0)
  FontMapOutput(FontIDA, "Mein Name ist Hase!", 10, 460, #FHL, #FVT, 0)

  If KeyboardReleased(#PB_Key_Pad1): hori = #FHR: vert = #FVT: col = Random($FFFFFF): zusatz$ = #CR$ + "(rechtsbndig, obenbndig)": EndIf
  If Keyboardreleased(#PB_Key_Pad2): hori = #FHC: vert = #FVT: col = Random($FFFFFF): zusatz$ = #CR$ + "(zentriert, obenbndig)": EndIf
  If Keyboardreleased(#PB_Key_Pad3): hori = #FHL: vert = #FVT: col = Random($FFFFFF): zusatz$ = #CR$ + "(linksbndig, obenbndig)": EndIf
  If Keyboardreleased(#PB_Key_Pad4): hori = #FHR: vert = #FVC: col = Random($FFFFFF): zusatz$ = #CR$ + "(rechtsbndig, zentriert)": EndIf
  If Keyboardreleased(#PB_Key_Pad5): hori = #FHC: vert = #FVC: col = Random($FFFFFF): zusatz$ = #CR$ + "(zentriert, zentriert)": EndIf
  If Keyboardreleased(#PB_Key_Pad6): hori = #FHL: vert = #FVC: col = Random($FFFFFF): zusatz$ = #CR$ + "(linksbndig, zentriert)": EndIf
  If Keyboardreleased(#PB_Key_Pad7): hori = #FHR: vert = #FVB: col = Random($FFFFFF): zusatz$ = #CR$ + "(rechtsbndig, untenbndig)": EndIf
  If Keyboardreleased(#PB_Key_Pad8): hori = #FHC: vert = #FVB: col = Random($FFFFFF): zusatz$ = #CR$ + "(zentriert, untenbndig)": EndIf
  If Keyboardreleased(#PB_Key_Pad9): hori = #FHL: vert = #FVB: col = Random($FFFFFF): zusatz$ = #CR$ + "(linksbndig, untenbndig)": EndIf

  If KeyboardPushed(#PB_Key_1): font = FontIDA: EndIf
  If KeyboardPushed(#PB_Key_2): font = FontID2: EndIf
  If KeyboardPushed(#PB_Key_3): font = FontID3: EndIf
  If KeyboardPushed(#PB_Key_4): font = FontID4: EndIf
  If KeyboardPushed(#PB_Key_5): font = FontID5: EndIf
  If KeyboardPushed(#PB_Key_6): font = FontID6: EndIf
  If KeyboardPushed(#PB_Key_7): font = FontID7: EndIf

  If KeyboardPushed(#PB_Key_Space): add$ = #CR$ + "eine weitere Zeile": Else: add$ = "": EndIf

  FontMapOutput(font, text$ + zusatz$ + add$, MouseX(), MouseY(), hori, vert, col)

  FlipBuffers()

Until KeyboardReleased(#PB_Key_Escape)
; ExecutableFormat=Windows
; DisableDebugger
; EOF